﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using PostSharp.Laos;
using System.Transactions;

namespace ConsoleApplication10
{
    [Serializable]
    class TransactionScopeAttribte : OnMethodBoundaryAspect
    {
   
        public override void OnEntry(MethodExecutionEventArgs eventArgs)
        {
            TransactionOptions transactionOptions = new TransactionOptions();
            TransactionScopeOption transactionScopeOption = TransactionScopeOption.Required;
            EnterpriseServicesInteropOption interopOption = EnterpriseServicesInteropOption.Automatic;
            eventArgs.MethodExecutionTag = new TransactionScope(transactionScopeOption, transactionOptions, interopOption);
        }
        public override void OnExit(MethodExecutionEventArgs eventArgs)
        {
            TransactionScope transactionScope = (TransactionScope)eventArgs.MethodExecutionTag;
            if (eventArgs.Exception == null)
            {
                transactionScope.Complete();
                transactionScope.Dispose();
            }
            else
            {
                transactionScope.Dispose();
            }
        }
    }
}
